'FFSubmenu=Exif
'FFName=Beschreibung <> Kommentar

'(c) Harald Maeckler, Dsseldorf 2016
' ***********************************************************************
' Beschreibung_Kommentar.vbs (Skript fr FixFoto)
' Beschreibungs-/Kommentartext kopieren, verschieben und tauschen
' ***********************************************************************
'
' Version 1.01 vom 28.11.2016	- Sicherung und Wiederherstellung mglich
' Version 1.00 vom 18.11.2016	- Betaversion
' ***********************************************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.01"
const SkriptURL = "http://www.ffsf.de/resources/beschreibung-kommentar.359/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim Abbruch,Antwort

'Spezifische Konstanten und Variable
Dim flag_BKop,flag_BVer,flag_KKop,flag_KVer,flag_KBTau
Dim action

Dim bilder,bild_array,Anz,AnzB,n,msg,pos
Dim beschreibung,kommentar
Dim ExifDatei,Datei

'Auswahl = Auswahltyp der Auswahl:
'0 = alle Dateien der Computeransicht
'1 = alle selektierten Dateien der Computeransicht
'2 = alle Dateien der aktuellen Bilderliste
'3 = alle selektierten Dateien der aktuellen Bilderliste
const Auswahl = 1

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "Beschreibung_Kommentar"						'Skriptname
const RegSchluessel = "FF_Beschreibung_Kommentar"			'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Beschreibung <> Kommentar **
FF_AddDialog "Beschreibung <> Kommentar",204,100
FF_AddControl "Beschreibung <> Kommentar","Fortschritt","PROGRESS",5,71,193,4
FF_AddControl "Beschreibung <> Kommentar","?","BUTTON",5,82,11,11
FF_AddControl "Beschreibung <> Kommentar","|","STATIC",18,82,22,11
FF_SetControlStyle "Beschreibung <> Kommentar","|",1
FF_AddControl "Beschreibung <> Kommentar","Update","BUTTON",42,82,33,11
FF_AddControl "Beschreibung <> Kommentar","Abbrechen","BUTTON",129,82,33,11
FF_AddControl "Beschreibung <> Kommentar","Start","BUTTON",165,82,33,11
FF_AddControl "Beschreibung <> Kommentar","&delete","BUTTON",0,0,1,1
FF_AddControl "Beschreibung <> Kommentar","flag_BKop","BOOL",5,15,8,8
FF_SetControlStyle "Beschreibung <> Kommentar","flag_BKop",16384
FF_AddControl "Beschreibung <> Kommentar","Beschreibung kopieren nach Kommentar","STATIC",18,14,106,10
FF_AddControl "Beschreibung <> Kommentar","flag_BVer","BOOL",5,25,8,8
FF_SetControlStyle "Beschreibung <> Kommentar","flag_BVer",16384
FF_AddControl "Beschreibung <> Kommentar","Beschreibung verschieben nach Kommentar","STATIC",18,24,106,10
FF_AddControl "Beschreibung <> Kommentar","flag_KKop","BOOL",5,35,8,8
FF_SetControlStyle "Beschreibung <> Kommentar","flag_KKop",16384
FF_AddControl "Beschreibung <> Kommentar","Kommentar kopieren nach Beschreibung","STATIC",18,34,106,10
FF_AddControl "Beschreibung <> Kommentar","flag_KVer","BOOL",5,45,8,8
FF_SetControlStyle "Beschreibung <> Kommentar","flag_KVer",16384
FF_AddControl "Beschreibung <> Kommentar","Kommentar verschieben nach Beschreibung","STATIC",18,44,106,10
FF_AddControl "Beschreibung <> Kommentar","flag_KBTau","BOOL",5,55,8,8
FF_SetControlStyle "Beschreibung <> Kommentar","flag_KBTau",16384
FF_AddControl "Beschreibung <> Kommentar","Kommentar und Beschreibung tauschen","STATIC",18,54,106,10
FF_AddControl "Beschreibung <> Kommentar","In allen markierten Bildern des akt. Computerverzeichnis","STATIC",4,2,140,10
FF_AddControl "Beschreibung <> Kommentar","Sicherung","BUTTON",150,24,48,11
FF_AddControl "Beschreibung <> Kommentar","Wiederherstellung","BUTTON",150,40,48,11
FF_AddControl "Beschreibung <> Kommentar","unterbrechen mit","STATIC",79,77,45,10
FF_SetControlStyle "Beschreibung <> Kommentar","unterbrechen mit",1
FF_AddControl "Beschreibung <> Kommentar","Taste Backspace","STATIC",79,86,45,10
FF_SetControlStyle "Beschreibung <> Kommentar","Taste Backspace",1
'** End Dialog Beschreibung <> Kommentar **

call RegistryLesen

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Beschreibung <> Kommentar","Sicherung", "" &_
						 "Backup der Beschreibungs- und Kommentartexte"
	FF_SetControlTooltip "Beschreibung <> Kommentar","Wiederherstellung", "" &_
						 "Recovery eines Backups, falls vorhanden"
	FF_SetControlTooltip "Beschreibung <> Kommentar","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "Beschreibung <> Kommentar","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Beschreibung <> Kommentar","Abbrechen", "" &_
						 "Skript beenden"
	FF_SetControlTooltip "Beschreibung <> Kommentar","Start", "" &_
						 "Starten der markierten Aktion"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500
FF_SetDialogTimer "Beschreibung <> Kommentar", 100
FF_ActivateControl "Beschreibung <> Kommentar","&delete"

do
	Abbruch = false
	Select Case FF_ShowDialog ("Beschreibung <> Kommentar")
	Case "TIMER"
		FF_SetControl "Beschreibung <> Kommentar" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Beschreibung <> Kommentar", 0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "flag_BKop"
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BKop",1
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BVer",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KKop",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KVer",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KBTau",0
	Case "flag_BVer"
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BKop",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BVer",1
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KKop",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KVer",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KBTau",0
	Case "flag_KKop"
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BKop",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BVer",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KKop",1
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KVer",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KBTau",0
	Case "flag_KVer"
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BKop",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BVer",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KKop",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KVer",1
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KBTau",0
	Case "flag_KBTau"
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BKop",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_BVer",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KKop",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KVer",0
		FF_SetControl "Beschreibung <> Kommentar" ,"flag_KBTau",1
	Case "Sicherung"
		call Vorbereitung
		if not Abbruch then call WerteSicherung
	Case "Wiederherstellung"
		call Vorbereitung
		if not Abbruch then call WerteWiederherstellung
	Case "?"
		'FF_SetControl "Beschreibung <> Kommentar","Fortschritt",65	'############## nur fr Screenshot
		WshShell.Popup "" & _
			"In den markierten Bildern des Computerverzeichnis knen die Text-" & vbNewLine &_
			"inhalte der Exif-Daten 'Beschreibung' und 'Kommentar' kopiert," & vbNewLine &_
			"verschoben und vertauscht werden." & vbNewLine & vbNewLine &_
			"Achtung:" & vbNewLine &_
			"----------" & vbNewLine &_
			"Ist der Kommentar mehrzeilig, wird nur die erste Zeile verwendet." & vbNewLine &_
			"Die restlichen Zeilen gehen verloren." & vbNewLine & vbNewLine &_
			"Ein gestarteter Ablauf kann mit der Backspace-Taste unterbrochen" & vbNewLine &_
			"werden." & vbNewLine & vbNewLine &_
			"Vor dem Kopieren, Verschieben oder Vertauschen knnen die Be-" & vbNewLine &_
			"schreibungs- und Kommentartexte (auch mehrzeilige) gesichert" & vbNewLine &_
			"und bei Bedarf wieder hergestellt werden." & vbNewLine & vbNewLine &_
			"Mit Bettigung der Tastenkombination Alt + D kann fr das Skript" & vbNewLine &_
			"eine Lschroutine aufgerufen werden." & vbNewLine &_
			"",,"Erluterungen",vbInformation
	Case "Update"
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "Abbrechen","CANCEL"
		exit do
	Case "Start"
		call Werte_auslesen
		call Vorbereitung
		if not Abbruch then
			call Schleife
			if not Abbruch then exit do
		end if

	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Beschreibung <> Kommentar")
if SkriptKill then			'ggf. Skript komplett entfernen
	call KillSkript
end if

end sub
'------------------------------------------------------------------------
Sub Vorbereitung

bilder = FF_GetSelection(Auswahl)
if len(bilder) = 0 then
	msgbox "Im Computerverzeichnis sind keine Bilder markiert!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

bild_Array = split(Bilder,vbNewLine)
Anz = ubound(bild_Array) +1 : AnzB = 0

end sub
'------------------------------------------------------------------------
Sub Schleife

For n = 0 to Anz -1
	FF_LoadImage bild_Array(n)
	if FF_HasExif then
	
		beschreibung = trim(FF_GetExifTag("ImageDescription"))
		kommentar = trim(FF_GetExifTag("UserComment"))
			pos = instr(kommentar,vbNewLine)
			if pos > 0 then kommentar = left(kommentar,pos -1)
	
		select case action
			case 1	'Beschreibung kopieren nach Kommentar
				FF_SetExifTag "UserComment",beschreibung
			case 2	'Beschreibung verschieben nach Kommentar
				FF_SetExifTag "UserComment",beschreibung
				FF_SetExifTag "ImageDescription",""
			case 3	'Kommentar kopieren nach Beschreibung
				FF_SetExifTag "ImageDescription",kommentar
			case 4	'Kommentar verschieben nach Beschreibung
				FF_SetExifTag "ImageDescription",kommentar
				FF_SetExifTag "UserComment",""
			case 5	'Kommentar und Beschreibung tauschen
				FF_SetExifTag "UserComment",beschreibung
				FF_SetExifTag "ImageDescription",kommentar
		end select
		
		FF_SaveExif bild_Array(n)
		AnzB = AnzB +1
	end if

	'### Fortschrittsanzeige
	FF_SetControl "Beschreibung <> Kommentar","Fortschritt",(n +1)/Anz*100

	'### Abbruch?
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & Anz & " Bildern wurden bisher " & n +1 & " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						 "Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then exit for
	end if
next

if Anz - AnzB > 0 then msg = vbNewLine & "Der Rest hate keine Exif-Daten." else msg = ""
msgbox  "Von " & Anz & " Bildern wurden " & AnzB & " Bilder bearbeitet." & msg,vbInformation,"Schlussmeldung"

End Sub
'------------------------------------------------------------------------
Sub WerteSicherung
Dim Sammlung,f

ExifDatei = FF_GetImagePath & "\" & "ExifDaten.txt"

if objFS.FileExists(ExifDatei) then
	Set f = objFS.GetFile(ExifDatei)
	Antwort = msgbox("Es ist eine Sicherung vorhanden vom" & vbNewLine &_
					  f.DateLastModified & vbNewLine & vbNewLine &_
					 "Soll sie berschrieben werden?",vbYesNo + vbQuestion,"Abfrage")
	if Antwort = vbNo then Abbruch = true : exit sub
end if

AnzB = 0
For n = 0 to Anz -1
	FF_LoadImage bild_Array(n)
	if FF_HasExif then

		Sammlung = Sammlung & "# " & bild_Array(n) & vbNewLine &_
				   FF_GetExifTag("ImageDescription") & vbNewLine &_
				   FF_GetExifTag("UserComment") & "#" & vbNewLine
		AnzB = AnzB +1
	end if
next

Set Datei = objFS.OpenTextFile(ExifDatei, ForWriting, true)
Datei.Write Sammlung
Datei.Close

WshShell.Popup "Bei " & AnzB & " Bildern von " & Anz & " wurden die" & vbNewLine & _
			   "Beschreibungs- und Kommentatexte gesichert!",2,"Beschreibung & Kommentar",vbInformation

End Sub
'------------------------------------------------------------------------
Sub WerteWiederherstellung
Dim Zeile,bild,komm

ExifDatei = FF_GetImagePath & "\" & "ExifDaten.txt"
if not objFS.FileExists(ExifDatei) then
	msgbox "Es ist keine Sicherungsdatei vorhanden!",vbInformation,"Info"
	Abbruch = true : exit sub
end if

Anz = 0 : AnzB = 0

Set Datei = objFS.OpenTextFile(ExifDatei, ForReading, True)
do Until Datei.AtEndOfStream
	Zeile = Datei.ReadLine
	if left(Zeile,1) = "#" then bild = mid(Zeile,3)
	Anz = Anz +1
	if objFS.FileExists(bild) then
		FF_LoadImage bild
		if FF_HasExif then
		
			Zeile = Datei.ReadLine
			FF_SetExifTag "ImageDescription", Zeile
			
			komm = ""
			do
				Zeile = Datei.ReadLine
				if right(Zeile,1) = "#" then
					komm = komm & left(Zeile,len(Zeile) -1)
					exit do
				else
					komm = komm & Zeile & vbNewLine
				end if
			loop
			FF_SetExifTag "UserComment", komm
			
			FF_SaveExif bild
			AnzB = AnzB +1
		end if
	end if
loop
Datei.Close

Antwort = msgbox("Bei " & AnzB & " Bildern von " & Anz & " wurden die" & vbNewLine & _
				 "Beschreibungs- und Kommentatexte wiederhergestellt!" & vbNewLine & vbNewLine &_
	   			 "Soll die Sicherungsdatei gelscht werden?",vbYesNo + vbQuestion,"Abfrage")
if Antwort = vbYes then objFS.DeleteFile ExifDatei,true

End Sub
'------------------------------------------------------------------------
Sub Werte_auslesen

flag_BKop = FF_GetControl ("Beschreibung <> Kommentar","flag_BKop")
flag_BVer = FF_GetControl ("Beschreibung <> Kommentar","flag_BVer")
flag_KKop = FF_GetControl ("Beschreibung <> Kommentar","flag_KKop")
flag_KVer = FF_GetControl ("Beschreibung <> Kommentar","flag_KVer")
flag_KBTau = FF_GetControl ("Beschreibung <> Kommentar","flag_KBTau")

if flag_BKop = 1 then
	action = 1
elseif flag_BVer = 1 then
	action = 2
elseif flag_KKop = 1 then
	action = 3
elseif flag_KVer = 1 then
	action = 4
elseif flag_KBTau = 1 then
	action = 5
end if

'action =
'1 wenn flag_BKop
'2 wenn flag_BVer
'3 wenn flag_KKop
'4 wenn flag_KVer
'5 wenn flag_KBTau

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

flag_BKop = FF_GetProfile (RegSchluessel,"flag_BKop")
if flag_BKop = "" then flag_BKop = 1

flag_BVer = FF_GetProfile (RegSchluessel,"flag_BVer")
if flag_BVer = "" then flag_BVer = 0

flag_KKop = FF_GetProfile (RegSchluessel,"flag_KKop")
if flag_KKop = "" then flag_KKop = 0

flag_KVer = FF_GetProfile (RegSchluessel,"flag_KVer")
if flag_KVer = "" then flag_KVer = 0

flag_KBTau = FF_GetProfile (RegSchluessel,"flag_KBTau")
if flag_KBTau = "" then flag_KBTau = 0

'### Werte eintragen
FF_SetControl "Beschreibung <> Kommentar","flag_BKop",flag_BKop
FF_SetControl "Beschreibung <> Kommentar","flag_BVer",flag_BVer
FF_SetControl "Beschreibung <> Kommentar","flag_KKop",flag_KKop
FF_SetControl "Beschreibung <> Kommentar","flag_KVer",flag_KVer
FF_SetControl "Beschreibung <> Kommentar","flag_KBTau",flag_KBTau

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Auslesen

'### Werte schreiben
FF_WriteProfile RegSchluessel,"flag_BKop",flag_BKop
FF_WriteProfile RegSchluessel,"flag_BVer",flag_BVer
FF_WriteProfile RegSchluessel,"flag_KKop",flag_KKop
FF_WriteProfile RegSchluessel,"flag_KVer",flag_KVer
FF_WriteProfile RegSchluessel,"flag_KBTau",flag_KBTau

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien lschen
'TempFile = """" & FF_GetScriptPath & "\SetDate\SetDate.pdf" & """"			'Dateien
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
'TempFile = FF_GetScriptPath & "\MeckiScript\SetDate"						'Ordner
'if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
